/*
 * Arbeitsaufteilung:
 * Marvin Hanke: 
 * Stefan Klbl: 
 * Boris Serdar: 
 * 
 */

/**
 * Diese Klasse stellt eine Test-Umgebung fr Lager, Lagerpltze, Waren, etc. bereit.
 * 
 * @author SK
 * 
 */
public class Test {

	/**
	 * Ausfhrbares Hauptprogramm.
	 * 
	 * @param args
	 */
	public static void main(String args[]) {

		// Erstellen der Test-Daten.
		Lager lager1 = new Lager(2, 2, 4, 3);
		Lager lager2 = new Lager(1, 3, 2, 1);
		Lager lager3 = new Lager(1, 1, 1, 1);

		System.out.println("> Lager 1 Lagerpltze Auslastung: ");
		lager1.utilization();
		System.out.println("\n> Lager 2 Lagerpltze Auslastung: ");
		lager2.utilization();
		System.out.println("\n> Lager 3 Lagerpltze Auslastung: ");
		lager3.utilization();

		// Allgemein als "Ware" deklarierte Waren, die mit new() mit einem spezifischen "Ware"-Sub-Typ als dynamischen Typ initialisiert werden.
		// Ware w1 hat zur Laufzeit z.B. den dynamischen Typ "Ware_Raumtemperatur".
		Ware w1 = new Ware_Raumtemperatur(1111, "Testware 11");
		Ware w2 = new Ware_gekuehlt(1112, "Testware 22");
		Ware w3 = new Ware_tiefgekuehlt_minus18(1113, "Testware 33");
		Ware w4 = new Ware_tiefgekuehlt_minus30(1114, "Testware 44");
		Ware w5 = new Ware_Raumtemperatur(1115, "Testware 55");
		Ware w6 = new Ware_gekuehlt(1116, "Testware 66");
		Ware w7 = new Ware_tiefgekuehlt_minus18(1117, "Testware 77");
		Ware w8 = new Ware_tiefgekuehlt_minus30(1118, "Testware 88");

		// Testen von Lager 1.
		System.out.println("\n> Fge w1 in Lager 1 ein: " + lager1.store(w1));
		System.out.println("\n> Fge w2 in Lager 1 ein: " + lager1.store(w2));
		System.out.println("\n> Fge w3 in Lager 1 ein: " + lager1.store(w3));
		System.out.println("\n> Fge w4 in Lager 1 ein: " + lager1.store(w4));

		System.out.println("\n> Lager 1 Lagerpltze Auslastung: ");
		lager1.utilization();
		System.out.println("\n> Lager 1 Inventar: ");
		lager1.inventar();

		System.out.println("\n> Fge w5 in Lager 1 ein: " + lager1.store(w5));
		System.out.println("\n> Da die Raumtemperatur Lagerpltze voll sind, muss das Einfgen von w5 "
				+ "in einem freien gekhlten Lagerplatz stattfinden!");
		System.out.println("\n> Fge w5 in Lager 1 ein: " + lager1.store(w5));

		System.out.println("\n> Lager 1 Lagerpltze Auslastung: ");
		lager1.utilization();
		System.out.println("\n> Lager 1 Inventar: ");
		lager1.inventar();

		System.out.println("\n> Raumtemperatur und gekhlte Lagerpltze sind nun voll ausgelastet!");
		System.out.println("> Erneutes Einfgen von w5 muss nun fehlschlagen!");
		System.out.println("\n> Fge w5 in Lager 1 ein: " + lager1.store(w5));

		System.out.println("\n> Lsche (erstes Vorkommen von) w5.");
		System.out.println("Referenz zum gelschten Objekt: " + lager1.remove(1115));

		System.out.println("\n> Lager 1 Lagerpltze Auslastung: ");
		lager1.utilization();
		System.out.println("\n> Lager 1 Inventar: ");
		lager1.inventar();

		// Testen von Lager 2.
		System.out.println("\n> Fge w5 in Lager 2 ein: " + lager2.store(w5));
		System.out.println("\n> Fge w6 in Lager 2 ein: " + lager2.store(w6));
		System.out.println("\n> Fge w7 in Lager 2 ein: " + lager2.store(w7));
		System.out.println("\n> Fge w7 in Lager 2 ein: " + lager2.store(w7));

		System.out.println("\n> Lager 2 Lagerpltze Auslastung: ");
		lager2.utilization();
		System.out.println("\n> Lager 2 Inventar: ");
		lager2.inventar();

		System.out.println("\n> Da die -18C Lagerpltze voll sind, muss das Einfgen von w3 im -30C "
				+ "Lagerplatz stattfinden!");
		System.out.println("\n> Fge w3 in Lager 2 ein: " + lager2.store(w3));

		System.out.println("\n> Lager 2 Lagerpltze Auslastung: ");
		lager2.utilization();
		System.out.println("\n> Lager 2 Inventar: ");
		lager2.inventar();

		// Testen von Lager 3.
		System.out.println("\n> Fge w1 in Lager 3 ein: " + lager3.store(w1));
		System.out.println("\n> Fge w2 in Lager 3 ein: " + lager3.store(w2));
		System.out.println("\n> Fge w3 in Lager 3 ein: " + lager3.store(w3));
		System.out.println("\n> Fge w4 in Lager 3 ein: " + lager3.store(w4));

		System.out.println("\n> Lager 3 Lagerpltze Auslastung: ");
		lager3.utilization();
		System.out.println("\n> Lager 3 Inventar: ");
		lager3.inventar();

		System.out.println("\n> Da das Lager komplett ausgelastet ist, muss das Einfgen der nchsten "
				+ "Ware fehlschlagen!");
		System.out.println("\n> Fge w1 in Lager 3 ein: " + lager3.store(w1));

		System.out.println("\n> Lsche (erstes Vorkommen von) w1.");
		System.out.println("Referenz zum gelschten Objekt: " + lager3.remove(1111));
		System.out.println("\n> Lsche (erstes Vorkommen von) w2.");
		System.out.println("Referenz zum gelschten Objekt: " + lager3.remove(1112));
		System.out.println("\n> Lsche (erstes Vorkommen von) w3.");
		System.out.println("Referenz zum gelschten Objekt: " + lager3.remove(1113));
		System.out.println("\n> Lsche (erstes Vorkommen von) w4.");
		System.out.println("Referenz zum gelschten Objekt: " + lager3.remove(1114));

		System.out.println("\n> Lager 3 Lagerpltze Auslastung: ");
		lager3.utilization();

		System.out.println("\n> Der Versuch, eine nicht im Lager vorhandene Ware zu lschen, muss fehlschlagen "
				+ "(daran erkennbar, dass null als Referenz zurckgegeben wird)!");
		System.out.println("\n> Lsche (erstes Vorkommen von) w4.");
		System.out.println("Referenz zum gelschten Objekt: " + lager3.remove(1114));
	}
}
