/**
 * Diese Klasse stellt Waren zur Verfgung, die in erster Linie in einem Lagerplatz bei Raumtemperatur gelagert werden
 * sollen.
 * 
 * @author SK
 * 
 */
public class Ware_Raumtemperatur extends Ware {

	/**
	 * Dieser Konstruktor erzeugt eine neue Ware mit bestimmter Seriennummer und bestimmtem Namen.
	 * 
	 * @param snr
	 *            Seriennummer der neuen Ware.
	 * @param name
	 *            Name der neuen Ware.
	 */
	public Ware_Raumtemperatur(int snr, String name) {
		this.Seriennummer = snr;
		this.Name = name;
	}

	/**
	 * Diese Methode fgt die Ware einem Lagerplatz bei Raumtemperatur hinzu, falls mglich. Auerdem wird angegeben, ob
	 * es sich hierbei um den ersten oder zweiten Versuch handelt.
	 * 
	 * @param l
	 *            Lagerplatz bei Raumtemperatur, in der die Ware gelagert werden soll.
	 * @return true wenn die Ware erfolgreich gelagert wurde, ansonsten false.
	 */
	public boolean storedInRaumtemperatur(Lagerplatz_Raumtemperatur l, boolean second_attempt) {
		if (second_attempt == false) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Diese Methode fgt die Ware einem gekhlten Lagerplatz hinzu, falls mglich. Auerdem wird angegeben, ob es sich
	 * hierbei um den ersten oder zweiten Versuch handelt.
	 * 
	 * @param l
	 *            Gekhlter Lagerplatz, in der die Ware gelagert werden soll.
	 * @return true wenn die Ware erfolgreich gelagert wurde, ansonsten false.
	 */
	public boolean storedInGekuehlt(Lagerplatz_gekuehlt l, boolean second_attempt) {
		if (second_attempt == true) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Diese Methode fgt die Ware einem auf -18C tiefgekhlten Lagerplatz hinzu, falls mglich. Auerdem wird
	 * angegeben, ob es sich hierbei um den ersten oder zweiten Versuch handelt.
	 * 
	 * @param l
	 *            Auf -18C gekhlter Lagerplatz, in der die Ware gelagert werden soll.
	 * @return true wenn die Ware erfolgreich gelagert wurde, ansonsten false.
	 */
	public boolean storedInTiefgekuehlt18(Lagerplatz_tiefgekuehlt_minus18 l, boolean second_attempt) {
		return false;
	}

	/**
	 * Diese Methode fgt die Ware einem auf -30C tiefgekhlten Lagerplatz hinzu, falls mglich. Auerdem wird
	 * angegeben, ob es sich hierbei um den ersten oder zweiten Versuch handelt.
	 * 
	 * @param l
	 *            Auf -30C gekhlter Lagerplatz, in der die Ware gelagert werden soll.
	 * @return true wenn die Ware erfolgreich gelagert wurde, ansonsten false.
	 */
	public boolean storedInTiefgekuehlt30(Lagerplatz_tiefgekuehlt_minus30 l, boolean second_attempt) {
		return false;
	}
}
